//
// jail.c
// A kick and dirty chrooted login shell implementation
//
//
// Juan M. Casillas <assman@gsyc.inf.uc3m.es>
// 3 / April / 2001 09:22
//
//
// $Id: jail.c,v 1.2 2001/04/03 10:28:36 assman Exp $
//
// $Log: jail.c,v $
// Revision 1.2  2001/04/03 10:28:36  assman
// removed binary file added by error
// added CVS tags
//
//
//
// Released under GNU Public License v.2.0
// See LICENSE file for details
//
// Compile command:
//
// cc -o jail jail.c
//
//
// Notes: 
//
// file must be owned by root and have the SUID permissions
// (4755 runs fine) to allow proper operation
//
// Bugs:
//
// some curious happen when trying to run jail in an IRIX 6.5
// when it starts, it becomes killed by itself. Tracing it, I
// think is a problem with the execve() system call. Workarrounds
// are wellcome.
//

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <pwd.h>

//
// customize your shell here
// note you need other libraries than
// the ones installed by the script
//

#define SHELL "/bin/bash"

#define HOME_VAR "HOME="
#define VERSION "1.0 stable"
//
// duplicate cad into the ptr pointer (ptr is an array of pointers)
//

void init_env(char **ptr, char *cad) {

    *ptr = (char *)malloc(strlen(cad)+1);
    memset(*ptr,0,strlen(cad)+1);
    strcpy(*ptr,cad);
}

int main(int argc, char *argv[], char *env[]) {
    int ret;
    char **lenv;
    char **larg;
    int n,j;
    struct passwd *pwdent;
    int uid, gid;
    char *home_dir;

    //
    // become root
    //

    if (argc > 1 && !strcmp(argv[1],"--version")) {
      fprintf(stderr,"\nJail version " VERSION "\n\n"
	             "This program is released under the GNU License\n"
	             "Juan M. Casillas <assman@gsyc.inf.uc3m.es>\n"
	             "See http://www.gsyc.inf.uc3m.es/~assman/jail\n"
	      "for more info\n\n"
	      "params:\n\n"
	      "\t--version: show this version\n\n"
	      "this program is mainly used for login users into the system\n"
	      "so interactive use is not useful, as you can see :)\n\n"
	      "Info ends, so bailing out.\n\n");
      exit(0);
    }
	             

    
    uid = getuid();
    gid = getgid();

    //
    // test if Im root
    //

    if (setgid(0) || setuid(0) || getuid() != geteuid() || 
	getgid() != getegid()) {
	fprintf(stderr,"I can't do the chroot() because Im not root");
    }
	
    //
    // get user information
    //

    pwdent = getpwuid(uid);

    //if (!getuid() && !getgid()) {
    //	puts("Im root");
    //    }
    

    if (env != NULL) {

	//
	// count elements and generate space for the array
	// then, save all the environment variables but don't
        // nothing in HOME and SHELL
        //

	n=0;
	while (env[n]) n++;  
	lenv = malloc(sizeof(char *)*n);

	n=j=0;
	while (env[n]) {
	    if ((strstr(env[n],"HOME")==NULL) && 
		(strstr(env[n],"SHELL")==NULL)) {
		init_env(&lenv[j],env[n]);  // copy argument
		//printf("%s\n",lenv[j]);
		j++;
	    }
	    n++;
	}	
    }
	
    //
    // now, override HOME and SHELL with our custom
    // values, so the jail runs fine
    //
    
    home_dir = (char *)malloc(strlen(HOME_VAR)+strlen(pwdent->pw_dir)+1);
    memset(home_dir,0,strlen(HOME_VAR)+strlen(pwdent->pw_dir)+1);
    strcpy(home_dir,HOME_VAR);
    strcat(home_dir,pwdent->pw_dir);


    init_env(&lenv[j],home_dir); j++;
    init_env(&lenv[j],"SHELL=" SHELL); j++;	
    lenv[j]=NULL;

    larg = malloc(sizeof(char *)*n);

    init_env(&larg[0],argv[0]);
    init_env(&larg[1],"-");
    larg[2]=NULL;

    //
    // change dir to the home directory
    //

    chdir(pwdent->pw_dir);	
    ret = chroot(pwdent->pw_dir);
    if (ret) { 
	perror("chroot() ");
	while(1);
	return(ret);
    }

    //
    // become the user
    //

    setgid(gid);
    setuid(uid);

    //
    // launch the shell overrinding current process space
    //

    ret = execve(SHELL,larg,lenv);
    if (ret) { 
	perror("execve() ");
	return(errno);
    }

    return(0); // not reached and if so, we are in trouble :(
}

    
